var dropperList = new Array('0', 
							'1',
							'2',
							'3',
							'4',
							'5',
							'6',
							'7',
							'8',
							'9',
							'10',
							'11',
							'12',
							'13',
							'14',
							'15',
							'16',
							'17',
							'18',
							'19',
							'20',
							'21',
							'22',
							'23',
							'24',
							'25',
							'26',
							'27',
							'28',
							'29',
							'30',
							'31',
							'32',
							'33',
							'34',
							'35',
							'36',
							'H',
							'T',
							'G',
							'U',
							'S',
							'R',
							'P1',
							'M1',
							'D1',
							'P2',
							'M2',
							'D2',
							'C34',
							'C35',
							'C36');

var ChipList = new Array('chip1',
						 'chip2',
						 'chip3',
						 'chip4',
						 'chip5',
						 'chip6');

var ROULETTE_FELD_TYPE_GREEN = 1;
var ROULETTE_FELD_TYPE_RED   = 2;
var ROULETTE_FELD_TYPE_BLACK = 3;

var Feldfarben = new Array(ROULETTE_FELD_TYPE_GREEN,	// 0
					 	   ROULETTE_FELD_TYPE_RED,		// 1
					 	   ROULETTE_FELD_TYPE_BLACK,	// 2
					 	   ROULETTE_FELD_TYPE_RED,		// 3
					  	   ROULETTE_FELD_TYPE_BLACK,	// 4
					  	   ROULETTE_FELD_TYPE_RED,		// 5
					  	   ROULETTE_FELD_TYPE_BLACK,	// 6
					  	   ROULETTE_FELD_TYPE_RED,		// 7
					  	   ROULETTE_FELD_TYPE_BLACK,	// 8
					  	   ROULETTE_FELD_TYPE_RED,		// 9
					  	   ROULETTE_FELD_TYPE_BLACK,	// 10
					  	   ROULETTE_FELD_TYPE_BLACK,	// 11
					  	   ROULETTE_FELD_TYPE_RED,		// 12
					  	   ROULETTE_FELD_TYPE_BLACK,	// 13
					  	   ROULETTE_FELD_TYPE_RED,		// 14
					  	   ROULETTE_FELD_TYPE_BLACK,	// 15
					  	   ROULETTE_FELD_TYPE_RED,		// 16
					  	   ROULETTE_FELD_TYPE_BLACK,	// 17
					  	   ROULETTE_FELD_TYPE_RED,		// 18
					  	   ROULETTE_FELD_TYPE_RED,		// 19
					  	   ROULETTE_FELD_TYPE_BLACK,	// 20
					  	   ROULETTE_FELD_TYPE_RED,		// 21
					  	   ROULETTE_FELD_TYPE_BLACK,	// 22
					  	   ROULETTE_FELD_TYPE_RED,		// 23
					  	   ROULETTE_FELD_TYPE_BLACK,	// 24
					  	   ROULETTE_FELD_TYPE_RED,		// 25
					  	   ROULETTE_FELD_TYPE_BLACK,	// 26
					  	   ROULETTE_FELD_TYPE_RED,		// 27
					  	   ROULETTE_FELD_TYPE_BLACK,	// 28
					  	   ROULETTE_FELD_TYPE_BLACK,	// 29
					  	   ROULETTE_FELD_TYPE_RED,		// 30
					  	   ROULETTE_FELD_TYPE_BLACK,	// 31
					  	   ROULETTE_FELD_TYPE_RED,		// 32
					  	   ROULETTE_FELD_TYPE_BLACK,	// 33
					  	   ROULETTE_FELD_TYPE_RED,		// 34
					  	   ROULETTE_FELD_TYPE_BLACK,	// 35
					  	   ROULETTE_FELD_TYPE_RED);		// 36

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//** htmlspecialchars *
//*
//* Quelle: Unbekannt
//*
function htmlspecialchars(str, typ){
	if(typeof str == "undefined")
		str = "";
	if(typeof typ != "number")
		typ = 2;
	
	typ = Math.max(0, Math.min(3, parseInt(typ)));
	var from = new Array(/&/g, /</g, />/g);
	var to = new Array("&amp;", "&lt;", "&gt;");
	
	if(typ==1 || typ==3){
		from.push(/'/g);
		to.push("&#039;");
	}
	if(typ==2 || typ==3){
		from.push(/"/g);
		to.push("&quot;");
	}
	
	for(var i in from)
		str = str.replace(from[i], to[i]);
	
	return str;
}
//*
//**

//** number_format *
//* 
//* Quelle: "http://www.fobit.com/"
//*
function number_format(number, decimals, dec_point, thousands_sep){
	var exponent = "";
	var numberstr = number.toString ();
	var eindex = numberstr.indexOf ("e");
	if (eindex > -1){
		exponent = numberstr.substring (eindex);
		number = parseFloat (numberstr.substring (0, eindex));
	}
	
	if (decimals != null){
		var temp = Math.pow (10, decimals);
		number = Math.round (number * temp) / temp;
	}
	var sign = number < 0 ? "-" : "";
	var integer = (number > 0 ? 
	Math.floor (number) : Math.abs (Math.ceil (number))).toString ();
	
	var fractional = number.toString ().substring (integer.length + sign.length);
	dec_point = dec_point != null ? dec_point : ".";
	fractional = decimals != null && decimals > 0 || fractional.length > 1 ? (dec_point + fractional.substring (1)) : "";
	if (decimals != null && decimals > 0){
		for (i = fractional.length - 1, z = decimals; i < z; ++i)
			fractional += "0";
	}
	
	thousands_sep = (thousands_sep != dec_point || fractional.length == 0) ? thousands_sep : null;
	if (thousands_sep != null && thousands_sep != ""){
		for (i = integer.length - 3; i > 0; i -= 3)
			integer = integer.substring (0 , i) + thousands_sep + integer.substring (i);
	}
	
	return sign + integer + fractional + exponent;
}
//*
//***

var TMessageLog = Class.create({
	initialize: function(){
		this.log = [];
	},
	add: function(message){
		this.log.push(new Array(new Date(), message));
	},
	write: function(i){
		date = this.log[i][0];
		return '['+date.getDate()+'.'+date.getMonth()+'.'+date.getFullYear()+' '+date.getHours()+':'+date.getMinutes()+':'+date.getSeconds()+'] '+this.log[i][1];
	},
	sprint: function(){
		result = '';
		
		for(i=0; i<this.log.length; i++){
			result += (this.write(i)+"\n");
		}
		
		return result;
	}
});

var TRoulette = Class.create({
	initialize: function(RURL){
		this.RequestURL = RURL;
		this.Log        = new TMessageLog();
		this.State		= {};
		this.Droppers   = new Array();
		
		for(i=0; i<dropperList.length; i++){
			this.Droppers[dropperList[i]] = new TDropper(ChipList);
		}
		
		this.Log.add('Created: URL="'+RURL+'"');
	},
	
	Error: function(msg){
		this.Log.add('ERROR - '+msg);
		this.MessageWnd('Es trat ein Fehler mit folgender Meldung auf:<br />\n<br />\n'+msg, 'msgfehler', true);
		//alert(msg);
		
	},
	
	GetEinsatz: function(){
		return this.State.Einsatz;
	},
	
	SetEinsatz: function(value){
		this.State.Einsatz = value;
	},
	
	GetGeld: function() {
		return this.State.Geld;
	},
	
	SetGeld: function(value){
		this.State.Geld = value;
	},
	
	GetState: function(){
		return this.State;
	},
	
	SetType: function(type){
		this.Type = type;
	},
	
	DisplayScore: function(){
		if(this.State.Geld != null){
			printScore($('roulette_feld'), 'Score1', this.State.Geld);
			$('Score1').style.position = 'absolute';
			$('Score1').style.top  = '8px';
			$('Score1').style.left = $('roulette_feld').getWidth()-$('Score1').getWidth()-3+'px';
		}
	},
	
	MessageWnd: function(msg, titleclass, modal){
		if($('msgwnd') != null){
			$('msgwnd').remove();
		}
		if($('modalbg') != null){
			$('modalbg').remove();
		}
		if(modal){
			mbg = Builder.node('div', {id: 'modalbg', class: 'modal'});
		}
		wnd = Builder.node('div', {id: 'msgwnd', class: 'message', style: 'left: 50%; top:50%; margin-left:-152px; margin-top:-102px;'});
		btn = Builder.node('div', {id: 'messagebtn'});
		title = Builder.node('div', {class: ('messagetitle '+titleclass).replace(/\s+$/,"")});
		msgd = Builder.node('div', {class: 'messagediv'});
		msgd.innerHTML = msg;
		
		if(modal){
			btn.observe('click', function(event){
				var element = Event.element(event);
				
				Effect.Fade($('modalbg'), 0.3);
				Effect.Fade(element.parentNode, 0.5);
				//element.parentNode.parentNode.remove();
			});
		}else{
			btn.observe('click', function(event){
				var element = Event.element(event);
				Effect.Fade(element.parentNode, 0.5);
				//element.parentNode.remove();
			});
		}
		
		wnd.appendChild(btn);
		wnd.appendChild(title);
		wnd.appendChild(msgd);
		wnd.hide();
		
		if(modal){
			document.body.appendChild(mbg);
			document.body.appendChild(wnd);
		}else{
			document.body.appendChild(wnd);
		}
		
		new Draggable(wnd, {zindex: 9900});
		Effect.Appear(wnd, 0.5);
	},
	
	ClearChips: function(){
		for(i=0; i<dropperList.length; i++){
			$('dropper_'+dropperList[i]+'_chips').childElements().each(function(elem){ elem.remove(); });
		}
	},
	
	UpdateState: function(func){
		this.Log.add('this.UpdateState:Request');
	
		$this = this;
		new Ajax.Request(this.RequestURL,{
			parameters: {type: "getstate"},
			onSuccess: function(transport, json){
				$this.Log.add('this.UpdateState:Request - Success ("'+transport.responseText+'" / '+json+')');
				
				$this.State = json || {};
				
				try{
					if(func != null){
						func(json);
					}
				}catch(e){
					$this.Error('this.UpdateState ERROR: "'+e+'"');
				}
			},
			onFailure: function(transport){
				$this.Log.add('this.UpdateState:Request - Failed ("'+transport.responseText+'")');
				
				$this.State = null;
				$this.Error('this.UpdateState AJAX ERROR >>>'+transport.responseText);
			}
		});
	},
	
	Spielen: function(){		
		$this = this;		
		
		aParams = '';
		for(iii=0; iii<dropperList.length; iii++){
			if(iii>0){
				aParams = aParams + ', ';
			}
			aParams = aParams + '"'+dropperList[iii]+'": '+this.Droppers[dropperList[iii]].JSON();
			this.Droppers[dropperList[iii]].reset();
		}
		
		new Ajax.Request(this.RequestURL,{
			parameters: {type: "spielen", params: '{'+aParams+'}'},
			onSuccess: function(transport, json){
				$this.Log.add('this.Spielen:Request - Success '+transport.responseText);
				
				$this.UpdateState(function(){
					$this.DisplayScore();
				});
				
				if(json != null){
					//$('DIV_Log').innerHTML = transport.responseText+"\n"+Object.toJSON(json);
					
					$this.State.Geld = json.Geld;
					$this.ClearChips();
					$this.DisplayScore();
					
					$this.MessageWnd('Die Kugel landete auf Feld <span class="feld_'+Feldfarben[json.Feld]+'">'+json.Feld+'</span>!<br />\nDein Gewinn betrgt: '+number_format(json.WettenContainer.Gewinn, 0, ',', '.')+'!<br />\nDu hast damit einen Score von '+number_format(json.Geld, 0, ',', '.')+'!', 'msgsergebnis');
				}else{
					$this.Log.add('this.Spielen:Request - Failed');
					$this.Error(transport.responseText);
					
					//$('DIV_Log').innerHTML = htmlspecialchars(transport.responseText);
					$this.ClearChips();
				}
			},
			onFailure: function(transport){
				$this.Log.add('this.Spielen:Request - Failed');
				
				$this.Error('this.Spielen AJAX ERROR >>>'+transport.responseText);
			}
		});
	}
});

var TDropper = Class.create({
	initialize: function(aChips){
		this.chips = aChips;
		this.chipsDropped = new Array();
		for(ii=0; ii<this.chips.length; ii++){
			this.chipsDropped[this.chips[ii]] = 0;
		}
	},
	add: function(chiptype){
		this.chipsDropped[chiptype]++;
	},
	reset: function(){
		for(ii=0; ii<this.chips.length; ii++){
			this.chipsDropped[this.chips[ii]] = 0;
		}
	},
	JSON: function(){
		result = '';
		
		for(ii=0; ii<this.chips.length; ii++){
			if(result.length > 0){
				result = result+', "'+this.chips[ii]+'": "'+this.chipsDropped[this.chips[ii]]+'"';
			}else{
				result = '"'+this.chips[ii]+'": "'+this.chipsDropped[this.chips[ii]]+'"';
			}
		}
		
		return '{'+result+'}';
	}
});

function printScore(elem,aid,value){
	if(!isNaN(value)){
		if($(aid) != null){
			$(aid).remove();
		}
				
		var cont = Builder.node('div', {id: aid, class: 'zahl_cont'});
		zahl = number_format(value, 0, ',', '.');
		
		for(i=0; i<zahl.length; i++){
			switch(zahl[i]){
				case '0':
					cont.appendChild(Builder.node('div', {class: 'zahl z0'}));
					break;
				case '1':
					cont.appendChild(Builder.node('div', {class: 'zahl z1'}));
					break;
				case '2':
					cont.appendChild(Builder.node('div', {class: 'zahl z2'}));
					break;
				case '3':
					cont.appendChild(Builder.node('div', {class: 'zahl z3'}));
					break;
				case '4':
					cont.appendChild(Builder.node('div', {class: 'zahl z4'}));
					break;
				case '5':
					cont.appendChild(Builder.node('div', {class: 'zahl z5'}));
					break;
				case '6':
					cont.appendChild(Builder.node('div', {class: 'zahl z6'}));
					break;
				case '7':
					cont.appendChild(Builder.node('div', {class: 'zahl z7'}));
					break;
				case '8':
					cont.appendChild(Builder.node('div', {class: 'zahl z8'}));
					break;
				case '9':
					cont.appendChild(Builder.node('div', {class: 'zahl z9'}));
					break;
				case '.':
					cont.appendChild(Builder.node('div', {class: 'zahl zdot'}));
					break;
				case ',':
					cont.appendChild(Builder.node('div', {class: 'zahl zcomma'}));
					break;
				case '!':
					cont.appendChild(Builder.node('div', {class: 'zahl zexcl'}));
					break;
				default: break;
			}
		}
		
		elem.appendChild(cont);
		
		return true;
	}else{
		return false;
	}
}

function cGenerate(type){
	var elem1 = $(type+'_elem');
	if(elem1 == null){
		$(type+'_holder').appendChild(Builder.node('div', {id: type+'_elem', class: 'abstractChip '+type}));
		new Draggable(type+'_elem', {revert: true});
	}
}

function dropperOnDrop(element, dropper){
	x = $w(element.className).last();
	y = dropper.id.replace('dropper_', '');
	Roulette.Droppers[dropper.id.replace('dropper_', '')].add(x);
	
	$('dropper_'+y+'_chips').childElements().each(function(elem){ elem.remove(); });
	for(i=0; i<ChipList.length; i++){
		$('dropper_'+y+'_chips').appendChild(Builder.node('div', {style: 'background:url('+dirA+'/img/'+ChipList[i]+'_'+(Math.min(15, Roulette.Droppers[y].chipsDropped[ChipList[i]]))+'.png) no-repeat center; width:100%; height:100%;'}));
	}
	
	//$('DIV_Log').innerHTML = x+' @ '+dropper.id+' | '+"\n"+Roulette.Droppers[y].JSON()+"\n"+Math.min(15, Roulette.Droppers[y].chipsDropped[x]);
	element.remove();
	cGenerate(x);
}